; init.l - basic functions built on 'mostly pure Lisp'
;
; check function
(define null (lambda (obj) (eq obj nil)))
; pickup function
(define first (lambda (ls) (car ls)))
(define second (lambda (ls) (car (cdr ls))))
(define third (lambda (ls) (car (cdr (cdr ls)))))
(define fourth (lambda (ls) (car (cdr (cdr (cdr ls))))))
(define fifth (lambda (ls) (car (cdr (cdr (cdr (cdr ls)))))))
(define sixth (lambda (ls) (car (cdr (cdr (cdr (cdr (cdr ls))))))))
(define seventh (lambda (ls) (car (cdr (cdr (cdr (cdr (cdr (cdr ls)))))))))
(define eighth (lambda (ls) (car (cdr (cdr (cdr (cdr (cdr (cdr (cdr ls))))))))))
(define ninth (lambda (ls) (car (cdr (cdr (cdr (cdr (cdr (cdr (cdr (cdr ls)))))))))))
(define tenth (lambda (ls) (car (cdr (cdr (cdr (cdr (cdr (cdr (cdr (cdr (cdr ls))))))))))))
(define cadr (lambda (ls) (second ls)))
(define caddr (lambda (ls) (third ls)))
(define cadddr (lambda (ls) (fourth ls)))
; arithmetic function
(define 1- (lambda (x) (- x 1)))
(define 1+ (lambda (x) (+ x 1)))
; list function based on generalized
(define fold-left (lambda (fn a ls) (if (null ls) a (fold-left fn (funcall fn a (car ls)) (cdr ls)))))
(define fold-right (lambda (fn a ls) (if (null ls) a (funcall fn (car ls) (fold-right fn a (cdr ls))))))
(define reverse (lambda (ls) (fold-left (lambda (x y) (cons y x)) nil ls)))
(define length (lambda (ls) (fold-left (lambda (x y) (+ x 1)) 0 ls)))
; mapcar: [restriction] if you change 'fnc' below to 'fn', it conflict with one in fold-right
(define mapcar (lambda (fnc ls) (fold-right (lambda (x y) (cons (funcall fnc x) y)) nil ls)))
